~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/tools/lib/bpf/Makefile

Version: ~ [ linux-6.12-rc7 ] ~ [ linux-6.11.7 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.60 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.116 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.171 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.229 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.285 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.323 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.12 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /tools/lib/bpf/Makefile (Version linux-6.12-rc7) and /tools/lib/bpf/Makefile (Version linux-5.7.19)


  1 # SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-      1 # SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
  2 # Most of this file is copied from tools/lib/t      2 # Most of this file is copied from tools/lib/traceevent/Makefile
  3                                                     3 
  4 RM ?= rm                                       << 
  5 srctree := $(realpath $(srctree))              << 
  6                                                << 
  7 VERSION_SCRIPT := libbpf.map                   << 
  8 LIBBPF_VERSION := $(shell \                         4 LIBBPF_VERSION := $(shell \
  9         grep -oE '^LIBBPF_([0-9.]+)' $(VERSION !!   5         grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | \
 10         sort -rV | head -n1 | cut -d'_' -f2)        6         sort -rV | head -n1 | cut -d'_' -f2)
 11 LIBBPF_MAJOR_VERSION := $(word 1,$(subst ., ,$ !!   7 LIBBPF_MAJOR_VERSION := $(firstword $(subst ., ,$(LIBBPF_VERSION)))
 12 LIBBPF_MINOR_VERSION := $(word 2,$(subst ., ,$ << 
 13                                                     8 
 14 MAKEFLAGS += --no-print-directory                   9 MAKEFLAGS += --no-print-directory
 15                                                    10 
 16 # This will work when bpf is built in tools en     11 # This will work when bpf is built in tools env. where srctree
 17 # isn't set and when invoked from selftests bu     12 # isn't set and when invoked from selftests build, where srctree
 18 # is a ".". building_out_of_srctree is undefin     13 # is a ".". building_out_of_srctree is undefined for in srctree
 19 # builds                                           14 # builds
 20 ifndef building_out_of_srctree                     15 ifndef building_out_of_srctree
 21 srctree := $(patsubst %/,%,$(dir $(CURDIR)))       16 srctree := $(patsubst %/,%,$(dir $(CURDIR)))
 22 srctree := $(patsubst %/,%,$(dir $(srctree)))      17 srctree := $(patsubst %/,%,$(dir $(srctree)))
 23 srctree := $(patsubst %/,%,$(dir $(srctree)))      18 srctree := $(patsubst %/,%,$(dir $(srctree)))
 24 #$(info Determined 'srctree' to be $(srctree))     19 #$(info Determined 'srctree' to be $(srctree))
 25 endif                                              20 endif
 26                                                    21 
 27 INSTALL = install                                  22 INSTALL = install
 28                                                    23 
 29 # Use DESTDIR for installing into a different      24 # Use DESTDIR for installing into a different root directory.
 30 # This is useful for building a package. The p     25 # This is useful for building a package. The program will be
 31 # installed in this directory as if it was the     26 # installed in this directory as if it was the root directory.
 32 # Then the build tool can move it later.           27 # Then the build tool can move it later.
 33 DESTDIR ?=                                         28 DESTDIR ?=
 34 DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'          29 DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'
 35                                                    30 
 36 include $(srctree)/tools/scripts/Makefile.arch     31 include $(srctree)/tools/scripts/Makefile.arch
 37                                                    32 
 38 ifeq ($(LP64), 1)                                  33 ifeq ($(LP64), 1)
 39   libdir_relative = lib64                          34   libdir_relative = lib64
 40 else                                               35 else
 41   libdir_relative = lib                            36   libdir_relative = lib
 42 endif                                              37 endif
 43                                                    38 
 44 prefix ?= /usr/local                               39 prefix ?= /usr/local
 45 libdir = $(prefix)/$(libdir_relative)              40 libdir = $(prefix)/$(libdir_relative)
 46 man_dir = $(prefix)/share/man                      41 man_dir = $(prefix)/share/man
 47 man_dir_SQ = '$(subst ','\'',$(man_dir))'          42 man_dir_SQ = '$(subst ','\'',$(man_dir))'
 48                                                    43 
 49 export man_dir man_dir_SQ INSTALL                  44 export man_dir man_dir_SQ INSTALL
 50 export DESTDIR DESTDIR_SQ                          45 export DESTDIR DESTDIR_SQ
 51                                                    46 
 52 include $(srctree)/tools/scripts/Makefile.incl     47 include $(srctree)/tools/scripts/Makefile.include
 53                                                    48 
 54 # copy a bit from Linux kbuild                     49 # copy a bit from Linux kbuild
 55                                                    50 
 56 ifeq ("$(origin V)", "command line")               51 ifeq ("$(origin V)", "command line")
 57   VERBOSE = $(V)                                   52   VERBOSE = $(V)
 58 endif                                              53 endif
 59 ifndef VERBOSE                                     54 ifndef VERBOSE
 60   VERBOSE = 0                                      55   VERBOSE = 0
 61 endif                                              56 endif
 62                                                    57 
 63 INCLUDES = -I$(or $(OUTPUT),.) \               !!  58 FEATURE_USER = .libbpf
 64            -I$(srctree)/tools/include -I$(srct !!  59 FEATURE_TESTS = libelf libelf-mmap zlib bpf reallocarray
                                                   >>  60 FEATURE_DISPLAY = libelf zlib bpf
                                                   >>  61 
                                                   >>  62 INCLUDES = -I. -I$(srctree)/tools/include -I$(srctree)/tools/arch/$(ARCH)/include/uapi -I$(srctree)/tools/include/uapi
                                                   >>  63 FEATURE_CHECK_CFLAGS-bpf = $(INCLUDES)
                                                   >>  64 
                                                   >>  65 check_feat := 1
                                                   >>  66 NON_CHECK_FEAT_TARGETS := clean TAGS tags cscope help
                                                   >>  67 ifdef MAKECMDGOALS
                                                   >>  68 ifeq ($(filter-out $(NON_CHECK_FEAT_TARGETS),$(MAKECMDGOALS)),)
                                                   >>  69   check_feat := 0
                                                   >>  70 endif
                                                   >>  71 endif
                                                   >>  72 
                                                   >>  73 ifeq ($(check_feat),1)
                                                   >>  74 ifeq ($(FEATURES_DUMP),)
                                                   >>  75 include $(srctree)/tools/build/Makefile.feature
                                                   >>  76 else
                                                   >>  77 include $(FEATURES_DUMP)
                                                   >>  78 endif
                                                   >>  79 endif
 65                                                    80 
 66 export prefix libdir src obj                       81 export prefix libdir src obj
 67                                                    82 
 68 # Shell quotes                                     83 # Shell quotes
 69 libdir_SQ = $(subst ','\'',$(libdir))              84 libdir_SQ = $(subst ','\'',$(libdir))
 70 libdir_relative_SQ = $(subst ','\'',$(libdir_r     85 libdir_relative_SQ = $(subst ','\'',$(libdir_relative))
 71                                                    86 
 72 OBJ             = $@                               87 OBJ             = $@
 73 N               =                                  88 N               =
 74                                                    89 
 75 LIB_TARGET      = libbpf.a libbpf.so.$(LIBBPF_     90 LIB_TARGET      = libbpf.a libbpf.so.$(LIBBPF_VERSION)
 76 LIB_FILE        = libbpf.a libbpf.so*              91 LIB_FILE        = libbpf.a libbpf.so*
 77 PC_FILE         = libbpf.pc                        92 PC_FILE         = libbpf.pc
 78                                                    93 
 79 # Set compile option CFLAGS                        94 # Set compile option CFLAGS
 80 ifdef EXTRA_CFLAGS                                 95 ifdef EXTRA_CFLAGS
 81   CFLAGS := $(EXTRA_CFLAGS)                        96   CFLAGS := $(EXTRA_CFLAGS)
 82 else                                               97 else
 83   CFLAGS := -g -O2                             !!  98   CFLAGS := -g -Wall
                                                   >>  99 endif
                                                   >> 100 
                                                   >> 101 ifeq ($(feature-libelf-mmap), 1)
                                                   >> 102   override CFLAGS += -DHAVE_LIBELF_MMAP_SUPPORT
                                                   >> 103 endif
                                                   >> 104 
                                                   >> 105 ifeq ($(feature-reallocarray), 0)
                                                   >> 106   override CFLAGS += -DCOMPAT_NEED_REALLOCARRAY
 84 endif                                             107 endif
 85                                                   108 
 86 # Append required CFLAGS                          109 # Append required CFLAGS
 87 override CFLAGS += -std=gnu89                  !! 110 override CFLAGS += $(EXTRA_WARNINGS)
 88 override CFLAGS += $(EXTRA_WARNINGS) -Wno-swit << 
 89 override CFLAGS += -Werror -Wall                  111 override CFLAGS += -Werror -Wall
                                                   >> 112 override CFLAGS += -fPIC
 90 override CFLAGS += $(INCLUDES)                    113 override CFLAGS += $(INCLUDES)
 91 override CFLAGS += -fvisibility=hidden            114 override CFLAGS += -fvisibility=hidden
 92 override CFLAGS += -D_LARGEFILE64_SOURCE -D_FI    115 override CFLAGS += -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
 93 override CFLAGS += $(CLANG_CROSS_FLAGS)        << 
 94                                                   116 
 95 # flags specific for shared library               117 # flags specific for shared library
 96 SHLIB_FLAGS := -DSHARED -fPIC                  !! 118 SHLIB_FLAGS := -DSHARED
 97                                                   119 
 98 ifeq ($(VERBOSE),1)                               120 ifeq ($(VERBOSE),1)
 99   Q =                                             121   Q =
100 else                                              122 else
101   Q = @                                           123   Q = @
102 endif                                             124 endif
103                                                   125 
104 # Disable command line variables (CFLAGS) over    126 # Disable command line variables (CFLAGS) override from top
105 # level Makefile (perf), otherwise build Makef    127 # level Makefile (perf), otherwise build Makefile will get
106 # the same command line setup.                    128 # the same command line setup.
107 MAKEOVERRIDES=                                    129 MAKEOVERRIDES=
108                                                   130 
109 all:                                              131 all:
110                                                   132 
111 OUTPUT ?= ./                                   << 
112 OUTPUT := $(abspath $(OUTPUT))/                << 
113 export srctree OUTPUT CC LD CFLAGS V              133 export srctree OUTPUT CC LD CFLAGS V
114 include $(srctree)/tools/build/Makefile.includ    134 include $(srctree)/tools/build/Makefile.include
115                                                   135 
116 SHARED_OBJDIR   := $(OUTPUT)sharedobjs/           136 SHARED_OBJDIR   := $(OUTPUT)sharedobjs/
117 STATIC_OBJDIR   := $(OUTPUT)staticobjs/           137 STATIC_OBJDIR   := $(OUTPUT)staticobjs/
118 BPF_IN_SHARED   := $(SHARED_OBJDIR)libbpf-in.o    138 BPF_IN_SHARED   := $(SHARED_OBJDIR)libbpf-in.o
119 BPF_IN_STATIC   := $(STATIC_OBJDIR)libbpf-in.o    139 BPF_IN_STATIC   := $(STATIC_OBJDIR)libbpf-in.o
                                                   >> 140 VERSION_SCRIPT  := libbpf.map
120 BPF_HELPER_DEFS := $(OUTPUT)bpf_helper_defs.h     141 BPF_HELPER_DEFS := $(OUTPUT)bpf_helper_defs.h
121 BPF_GENERATED   := $(BPF_HELPER_DEFS)          << 
122                                                   142 
123 LIB_TARGET      := $(addprefix $(OUTPUT),$(LIB    143 LIB_TARGET      := $(addprefix $(OUTPUT),$(LIB_TARGET))
124 LIB_FILE        := $(addprefix $(OUTPUT),$(LIB    144 LIB_FILE        := $(addprefix $(OUTPUT),$(LIB_FILE))
125 PC_FILE         := $(addprefix $(OUTPUT),$(PC_    145 PC_FILE         := $(addprefix $(OUTPUT),$(PC_FILE))
126                                                   146 
127 TAGS_PROG := $(if $(shell which etags 2>/dev/n    147 TAGS_PROG := $(if $(shell which etags 2>/dev/null),etags,ctags)
128                                                   148 
129 GLOBAL_SYM_COUNT = $(shell readelf -s --wide $    149 GLOBAL_SYM_COUNT = $(shell readelf -s --wide $(BPF_IN_SHARED) | \
130                            cut -d "@" -f1 | se    150                            cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' | \
131                            sed 's/\[.*\]//' |     151                            sed 's/\[.*\]//' | \
132                            awk '/GLOBAL/ && /D !! 152                            awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}' | \
133                            sort -u | wc -l)       153                            sort -u | wc -l)
134 VERSIONED_SYM_COUNT = $(shell readelf --dyn-sy !! 154 VERSIONED_SYM_COUNT = $(shell readelf -s --wide $(OUTPUT)libbpf.so | \
135                               sed 's/\[.*\]//' << 
136                               awk '/GLOBAL/ && << 
137                               grep -Eo '[^ ]+@    155                               grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 | sort -u | wc -l)
138                                                   156 
139 CMD_TARGETS = $(LIB_TARGET) $(PC_FILE)            157 CMD_TARGETS = $(LIB_TARGET) $(PC_FILE)
140                                                   158 
141 all: fixdep                                       159 all: fixdep
142         $(Q)$(MAKE) all_cmd                       160         $(Q)$(MAKE) all_cmd
143                                                   161 
144 all_cmd: $(CMD_TARGETS) check                     162 all_cmd: $(CMD_TARGETS) check
145                                                   163 
146 $(SHARED_OBJDIR) $(STATIC_OBJDIR):             !! 164 $(BPF_IN_SHARED): force elfdep zdep bpfdep $(BPF_HELPER_DEFS)
147         $(Q)mkdir -p $@                        << 
148                                                << 
149 $(BPF_IN_SHARED): force $(BPF_GENERATED) | $(S << 
150         @(test -f ../../include/uapi/linux/bpf    165         @(test -f ../../include/uapi/linux/bpf.h -a -f ../../../include/uapi/linux/bpf.h && ( \
151         (diff -B ../../include/uapi/linux/bpf.    166         (diff -B ../../include/uapi/linux/bpf.h ../../../include/uapi/linux/bpf.h >/dev/null) || \
152         echo "Warning: Kernel ABI header at 't    167         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf.h' differs from latest version at 'include/uapi/linux/bpf.h'" >&2 )) || true
153         @(test -f ../../include/uapi/linux/bpf    168         @(test -f ../../include/uapi/linux/bpf_common.h -a -f ../../../include/uapi/linux/bpf_common.h && ( \
154         (diff -B ../../include/uapi/linux/bpf_    169         (diff -B ../../include/uapi/linux/bpf_common.h ../../../include/uapi/linux/bpf_common.h >/dev/null) || \
155         echo "Warning: Kernel ABI header at 't    170         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf_common.h' differs from latest version at 'include/uapi/linux/bpf_common.h'" >&2 )) || true
                                                   >> 171         @(test -f ../../include/uapi/linux/netlink.h -a -f ../../../include/uapi/linux/netlink.h && ( \
                                                   >> 172         (diff -B ../../include/uapi/linux/netlink.h ../../../include/uapi/linux/netlink.h >/dev/null) || \
                                                   >> 173         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/netlink.h' differs from latest version at 'include/uapi/linux/netlink.h'" >&2 )) || true
                                                   >> 174         @(test -f ../../include/uapi/linux/if_link.h -a -f ../../../include/uapi/linux/if_link.h && ( \
                                                   >> 175         (diff -B ../../include/uapi/linux/if_link.h ../../../include/uapi/linux/if_link.h >/dev/null) || \
                                                   >> 176         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_link.h' differs from latest version at 'include/uapi/linux/if_link.h'" >&2 )) || true
156         @(test -f ../../include/uapi/linux/if_    177         @(test -f ../../include/uapi/linux/if_xdp.h -a -f ../../../include/uapi/linux/if_xdp.h && ( \
157         (diff -B ../../include/uapi/linux/if_x    178         (diff -B ../../include/uapi/linux/if_xdp.h ../../../include/uapi/linux/if_xdp.h >/dev/null) || \
158         echo "Warning: Kernel ABI header at 't    179         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_xdp.h' differs from latest version at 'include/uapi/linux/if_xdp.h'" >&2 )) || true
159         $(SILENT_MAKE) -C $(srctree)/tools/bui << 
160         $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(S    180         $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(SHARED_OBJDIR) CFLAGS="$(CFLAGS) $(SHLIB_FLAGS)"
161                                                   181 
162 $(BPF_IN_STATIC): force $(BPF_GENERATED) | $(S !! 182 $(BPF_IN_STATIC): force elfdep zdep bpfdep $(BPF_HELPER_DEFS)
163         $(SILENT_MAKE) -C $(srctree)/tools/bui << 
164         $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(S    183         $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(STATIC_OBJDIR)
165                                                   184 
166 $(BPF_HELPER_DEFS): $(srctree)/tools/include/u    185 $(BPF_HELPER_DEFS): $(srctree)/tools/include/uapi/linux/bpf.h
167         $(QUIET_GEN)$(srctree)/scripts/bpf_doc !! 186         $(QUIET_GEN)$(srctree)/scripts/bpf_helpers_doc.py --header \
168                 --file $(srctree)/tools/includ    187                 --file $(srctree)/tools/include/uapi/linux/bpf.h > $(BPF_HELPER_DEFS)
169                                                   188 
170 $(OUTPUT)libbpf.so: $(OUTPUT)libbpf.so.$(LIBBP    189 $(OUTPUT)libbpf.so: $(OUTPUT)libbpf.so.$(LIBBPF_VERSION)
171                                                   190 
172 $(OUTPUT)libbpf.so.$(LIBBPF_VERSION): $(BPF_IN !! 191 $(OUTPUT)libbpf.so.$(LIBBPF_VERSION): $(BPF_IN_SHARED)
173         $(QUIET_LINK)$(CC) $(CFLAGS) $(LDFLAGS !! 192         $(QUIET_LINK)$(CC) $(LDFLAGS) \
174                 --shared -Wl,-soname,libbpf.so    193                 --shared -Wl,-soname,libbpf.so.$(LIBBPF_MAJOR_VERSION) \
175                 -Wl,--version-script=$(VERSION !! 194                 -Wl,--version-script=$(VERSION_SCRIPT) $^ -lelf -lz -o $@
176         @ln -sf $(@F) $(OUTPUT)libbpf.so          195         @ln -sf $(@F) $(OUTPUT)libbpf.so
177         @ln -sf $(@F) $(OUTPUT)libbpf.so.$(LIB    196         @ln -sf $(@F) $(OUTPUT)libbpf.so.$(LIBBPF_MAJOR_VERSION)
178                                                   197 
179 $(OUTPUT)libbpf.a: $(BPF_IN_STATIC)               198 $(OUTPUT)libbpf.a: $(BPF_IN_STATIC)
180         $(QUIET_LINK)$(RM) -f $@; $(AR) rcs $@ !! 199         $(QUIET_LINK)$(RM) $@; $(AR) rcs $@ $^
181                                                   200 
182 $(OUTPUT)libbpf.pc:                               201 $(OUTPUT)libbpf.pc:
183         $(QUIET_GEN)sed -e "s|@PREFIX@|$(prefi    202         $(QUIET_GEN)sed -e "s|@PREFIX@|$(prefix)|" \
184                 -e "s|@LIBDIR@|$(libdir_SQ)|"     203                 -e "s|@LIBDIR@|$(libdir_SQ)|" \
185                 -e "s|@VERSION@|$(LIBBPF_VERSI    204                 -e "s|@VERSION@|$(LIBBPF_VERSION)|" \
186                 < libbpf.pc.template > $@         205                 < libbpf.pc.template > $@
187                                                   206 
188 check: check_abi check_version                 !! 207 check: check_abi
189                                                   208 
190 check_abi: $(OUTPUT)libbpf.so $(VERSION_SCRIPT !! 209 check_abi: $(OUTPUT)libbpf.so
191         @if [ "$(GLOBAL_SYM_COUNT)" != "$(VERS    210         @if [ "$(GLOBAL_SYM_COUNT)" != "$(VERSIONED_SYM_COUNT)" ]; then  \
192                 echo "Warning: Num of global s    211                 echo "Warning: Num of global symbols in $(BPF_IN_SHARED)"        \
193                      "($(GLOBAL_SYM_COUNT)) do    212                      "($(GLOBAL_SYM_COUNT)) does NOT match with num of"  \
194                      "versioned symbols in $^     213                      "versioned symbols in $^ ($(VERSIONED_SYM_COUNT))." \
195                      "Please make sure all LIB    214                      "Please make sure all LIBBPF_API symbols are"       \
196                      "versioned in $(VERSION_S    215                      "versioned in $(VERSION_SCRIPT)." >&2;              \
197                 readelf -s --wide $(BPF_IN_SHA    216                 readelf -s --wide $(BPF_IN_SHARED) |                     \
198                     cut -d "@" -f1 | sed 's/_v    217                     cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' |   \
199                     sed 's/\[.*\]//' |            218                     sed 's/\[.*\]//' |                                   \
200                     awk '/GLOBAL/ && /DEFAULT/    219                     awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}'|  \
201                     sort -u > $(OUTPUT)libbpf_    220                     sort -u > $(OUTPUT)libbpf_global_syms.tmp;           \
202                 readelf --dyn-syms --wide $(OU !! 221                 readelf -s --wide $(OUTPUT)libbpf.so |                   \
203                     sed 's/\[.*\]//' |         << 
204                     awk '/GLOBAL/ && /DEFAULT/ << 
205                     grep -Eo '[^ ]+@LIBBPF_' |    222                     grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 |             \
206                     sort -u > $(OUTPUT)libbpf_    223                     sort -u > $(OUTPUT)libbpf_versioned_syms.tmp;        \
207                 diff -u $(OUTPUT)libbpf_global    224                 diff -u $(OUTPUT)libbpf_global_syms.tmp                  \
208                      $(OUTPUT)libbpf_versioned    225                      $(OUTPUT)libbpf_versioned_syms.tmp;                 \
209                 rm $(OUTPUT)libbpf_global_syms    226                 rm $(OUTPUT)libbpf_global_syms.tmp                       \
210                    $(OUTPUT)libbpf_versioned_s    227                    $(OUTPUT)libbpf_versioned_syms.tmp;                   \
211                 exit 1;                           228                 exit 1;                                                  \
212         fi                                        229         fi
213                                                   230 
214 HDR_MAJ_VERSION := $(shell grep -oE '^$(pound) << 
215 HDR_MIN_VERSION := $(shell grep -oE '^$(pound) << 
216                                                << 
217 check_version: $(VERSION_SCRIPT) libbpf_versio << 
218         @if [ "$(HDR_MAJ_VERSION)" != "$(LIBBP << 
219                 echo "Error: libbpf major vers << 
220                      "'$(HDR_MAJ_VERSION)' !=  << 
221                 exit 1;                        << 
222         fi                                     << 
223         @if [ "$(HDR_MIN_VERSION)" != "$(LIBBP << 
224                 echo "Error: libbpf minor vers << 
225                      "'$(HDR_MIN_VERSION)' !=  << 
226                 exit 1;                        << 
227         fi                                     << 
228                                                << 
229 define do_install_mkdir                           231 define do_install_mkdir
230         if [ ! -d '$(DESTDIR_SQ)$1' ]; then       232         if [ ! -d '$(DESTDIR_SQ)$1' ]; then             \
231                 $(INSTALL) -d -m 755 '$(DESTDI    233                 $(INSTALL) -d -m 755 '$(DESTDIR_SQ)$1'; \
232         fi                                        234         fi
233 endef                                             235 endef
234                                                   236 
235 define do_install                                 237 define do_install
236         if [ ! -d '$(DESTDIR_SQ)$2' ]; then       238         if [ ! -d '$(DESTDIR_SQ)$2' ]; then             \
237                 $(INSTALL) -d -m 755 '$(DESTDI    239                 $(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2'; \
238         fi;                                       240         fi;                                             \
239         $(INSTALL) $(if $3,-m $3,) $1 '$(DESTD !! 241         $(INSTALL) $1 $(if $3,-m $3,) '$(DESTDIR_SQ)$2'
240 endef                                             242 endef
241                                                   243 
242 install_lib: all_cmd                              244 install_lib: all_cmd
243         $(call QUIET_INSTALL, $(LIB_TARGET)) \    245         $(call QUIET_INSTALL, $(LIB_TARGET)) \
244                 $(call do_install_mkdir,$(libd    246                 $(call do_install_mkdir,$(libdir_SQ)); \
245                 cp -fpR $(LIB_FILE) $(DESTDIR)    247                 cp -fpR $(LIB_FILE) $(DESTDIR)$(libdir_SQ)
246                                                   248 
247 SRC_HDRS := bpf.h libbpf.h btf.h libbpf_common !! 249 install_headers: $(BPF_HELPER_DEFS)
248             bpf_helpers.h bpf_tracing.h bpf_en !! 250         $(call QUIET_INSTALL, headers) \
249             skel_internal.h libbpf_version.h u !! 251                 $(call do_install,bpf.h,$(prefix)/include/bpf,644); \
250 GEN_HDRS := $(BPF_GENERATED)                   !! 252                 $(call do_install,libbpf.h,$(prefix)/include/bpf,644); \
251                                                !! 253                 $(call do_install,btf.h,$(prefix)/include/bpf,644); \
252 INSTALL_PFX := $(DESTDIR)$(prefix)/include/bpf !! 254                 $(call do_install,libbpf_util.h,$(prefix)/include/bpf,644); \
253 INSTALL_SRC_HDRS := $(addprefix $(INSTALL_PFX) !! 255                 $(call do_install,libbpf_common.h,$(prefix)/include/bpf,644); \
254 INSTALL_GEN_HDRS := $(addprefix $(INSTALL_PFX) !! 256                 $(call do_install,xsk.h,$(prefix)/include/bpf,644); \
255                                                !! 257                 $(call do_install,bpf_helpers.h,$(prefix)/include/bpf,644); \
256 $(INSTALL_SRC_HDRS): $(INSTALL_PFX)/%.h: %.h   !! 258                 $(call do_install,$(BPF_HELPER_DEFS),$(prefix)/include/bpf,644); \
257         $(call QUIET_INSTALL, $@) \            !! 259                 $(call do_install,bpf_tracing.h,$(prefix)/include/bpf,644); \
258                 $(call do_install,$<,$(prefix) !! 260                 $(call do_install,bpf_endian.h,$(prefix)/include/bpf,644); \
259                                                !! 261                 $(call do_install,bpf_core_read.h,$(prefix)/include/bpf,644);
260 $(INSTALL_GEN_HDRS): $(INSTALL_PFX)/%.h: $(OUT << 
261         $(call QUIET_INSTALL, $@) \            << 
262                 $(call do_install,$<,$(prefix) << 
263                                                << 
264 install_headers: $(BPF_GENERATED) $(INSTALL_SR << 
265         $(call QUIET_INSTALL, libbpf_headers)  << 
266                                                   262 
267 install_pkgconfig: $(PC_FILE)                     263 install_pkgconfig: $(PC_FILE)
268         $(call QUIET_INSTALL, $(PC_FILE)) \       264         $(call QUIET_INSTALL, $(PC_FILE)) \
269                 $(call do_install,$(PC_FILE),$    265                 $(call do_install,$(PC_FILE),$(libdir_SQ)/pkgconfig,644)
270                                                   266 
271 install: install_lib install_pkgconfig install !! 267 install: install_lib install_pkgconfig
                                                   >> 268 
                                                   >> 269 ### Cleaning rules
                                                   >> 270 
                                                   >> 271 config-clean:
                                                   >> 272         $(call QUIET_CLEAN, config)
                                                   >> 273         $(Q)$(MAKE) -C $(srctree)/tools/build/feature/ clean >/dev/null
272                                                   274 
273 clean: fixdep-clean                            !! 275 clean:
274         $(call QUIET_CLEAN, libbpf) $(RM) -rf     276         $(call QUIET_CLEAN, libbpf) $(RM) -rf $(CMD_TARGETS)                 \
275                 *~ .*.d .*.cmd LIBBPF-CFLAGS $ !! 277                 *~ .*.d .*.cmd LIBBPF-CFLAGS $(BPF_HELPER_DEFS)              \
276                 $(SHARED_OBJDIR) $(STATIC_OBJD    278                 $(SHARED_OBJDIR) $(STATIC_OBJDIR)                            \
277                 $(addprefix $(OUTPUT),            279                 $(addprefix $(OUTPUT),                                       \
278                             *.o *.a *.so *.so.    280                             *.o *.a *.so *.so.$(LIBBPF_MAJOR_VERSION) *.pc)
                                                   >> 281         $(call QUIET_CLEAN, core-gen) $(RM) $(OUTPUT)FEATURE-DUMP.libbpf
279                                                   282 
280 PHONY += force cscope tags check check_abi che !! 283 
                                                   >> 284 
                                                   >> 285 PHONY += force elfdep zdep bpfdep cscope tags
281 force:                                            286 force:
282                                                   287 
                                                   >> 288 elfdep:
                                                   >> 289         @if [ "$(feature-libelf)" != "1" ]; then echo "No libelf found"; exit 1 ; fi
                                                   >> 290 
                                                   >> 291 zdep:
                                                   >> 292         @if [ "$(feature-zlib)" != "1" ]; then echo "No zlib found"; exit 1 ; fi
                                                   >> 293 
                                                   >> 294 bpfdep:
                                                   >> 295         @if [ "$(feature-bpf)" != "1" ]; then echo "BPF API too old"; exit 1 ; fi
                                                   >> 296 
283 cscope:                                           297 cscope:
284         ls *.c *.h > cscope.files                 298         ls *.c *.h > cscope.files
285         cscope -b -q -I $(srctree)/include -f     299         cscope -b -q -I $(srctree)/include -f cscope.out
286                                                   300 
287 tags:                                             301 tags:
288         $(RM) -f TAGS tags                     !! 302         rm -f TAGS tags
289         ls *.c *.h | xargs $(TAGS_PROG) -a        303         ls *.c *.h | xargs $(TAGS_PROG) -a
290                                                   304 
291 # Declare the contents of the .PHONY variable     305 # Declare the contents of the .PHONY variable as phony.  We keep that
292 # information in a variable so we can use it i    306 # information in a variable so we can use it in if_changed and friends.
293 .PHONY: $(PHONY)                                  307 .PHONY: $(PHONY)
294                                                   308 
295 # Delete partially updated (corrupted) files o    309 # Delete partially updated (corrupted) files on error
296 .DELETE_ON_ERROR:                                 310 .DELETE_ON_ERROR:
297                                                << 
298 help:                                          << 
299         @echo 'libbpf common targets:'         << 
300         @echo '  HINT: use "V=1" to enable ver << 
301         @echo '  all     - build libraries and << 
302         @echo '  clean   - remove all generate << 
303         @echo '  check   - check ABI and versi << 
304         @echo ''                               << 
305         @echo 'libbpf install targets:'        << 
306         @echo '  HINT: use "prefix"(defaults t << 
307         @echo '        to adjust target destin << 
308         @echo '  install          - build and  << 
309         @echo '  install_headers  - install on << 
310         @echo ''                               << 
311         @echo 'libbpf make targets:'           << 
312         @echo '  tags    - use ctags to make t << 
313         @echo '  cscope  - use cscope to make  << 
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php